package com.henryhiles.qweather.di

import com.henryhiles.qweather.domain.remote.WeatherApi
import com.henryhiles.qweather.presentation.screenmodel.AppearancePreferenceManager
import com.henryhiles.qweather.presentation.screenmodel.AppearancePreferencesScreenModel
import com.henryhiles.qweather.presentation.screenmodel.DailyWeatherScreenModel
import com.henryhiles.qweather.presentation.screenmodel.HourlyWeatherScreenModel
import org.koin.core.module.dsl.factoryOf
import org.koin.core.module.dsl.singleOf
import org.koin.dsl.module
import retrofit2.Retrofit
import retrofit2.converter.moshi.MoshiConverterFactory
import retrofit2.create

//@Module
//@InstallIn(SingletonComponent::class)
//object AppModule {
//    @Provides
//    @Singleton
//    fun provideWeatherApi(): WeatherApi {
//        return Retrofit.Builder().baseUrl("https://api.open-meteo.com")
//            .addConverterFactory(MoshiConverterFactory.create()).build().create()
//    }
//
//    @Provides
//    @Singleton
//    fun provideFusedLocationProviderClient(app: Application): FusedLocationProviderClient {
//        return LocationServices.getFusedLocationProviderClient(app)
//    }
//}

val appModule = module {
    fun provideWeatherApi(): WeatherApi {
        return Retrofit.Builder().baseUrl("https://api.open-meteo.com")
            .addConverterFactory(MoshiConverterFactory.create()).build().create()
    }

    singleOf(::provideWeatherApi)
    singleOf(::AppearancePreferenceManager)

    factoryOf(::AppearancePreferencesScreenModel)
    factoryOf(::HourlyWeatherScreenModel)
    factoryOf(::DailyWeatherScreenModel)
}